/* SimpleStorage.h -- simple implementation of Onion::Storage to testing
		      and developent purposes.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

#ifndef SIMPLE_STORAGE_H
#define SIMPLE_STORAGE_H

#include "registry.h"
#include <fstream>
#include <iostream>

namespace Onion {
///////////////////////////////////////////////////////////////////////////////
/// @brief Very simple and buggy Storage class
///
/// This storage have some misadvatages of realy good Storage. First of them
/// is limit variable.size + value.size() by 1024 max value. And second, is
/// Storage can't store unformated data. 3th, is buggy with using '='
/// character in variable names. And at last it cant store variables with ""
/// name and same value. But this Storage have enought functionality for test 
/// and develop purposes.
///////////////////////////////////////////////////////////////////////////////

	class SimpleStorage : public Storage
	{
	public:
		SimpleStorage(const std::string &filename)
			: state(CLOSED), name(filename), ifile(0), ofile(0) {};
	
		void open(bool read);
		void close();
		void save( const std::string &variable,
			const std::string &value);
		void saveMarker(const std::string &marker,
			const std::string &value);
		bool load(std::string &variable, std::string &value );
	private:
		enum {CLOSED, LOAD, STORE} state;
		std::string name;
		std::ifstream *ifile;
		std::ofstream *ofile;
	}; // class SimpleStorage
}; // namespace Onion

#endif // SIMPLE_STORAGE_H

// <EOF>
