/* registry.cpp -- realization of Onion Registry library

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */


//#include <iostream>

#include "registry.h"

using namespace Onion;

MetaKey::MetaKey() throw(std::bad_alloc) : owner_parent(false)
{
}

MetaKey::MetaKey(const std::string &val) throw(std::bad_alloc)
	: value(val), owner_parent(false)
{
}

MetaKey &MetaKey::operator=(const std::string &val) throw()
{
	value = val;
}

std::string MetaKey::getValue() const throw(std::bad_alloc)
{
	return value;
}

MetaKey::operator std::string() const throw(std::bad_alloc)
{
	return value;
}

bool MetaKey::getOwnerParent() const throw()
{
	return owner_parent;
}

void MetaKey::setOwnerParent( bool o_p ) throw()
{
	owner_parent = o_p;
}

// <EOF>
