/* registry.cpp -- realization of Onion Registry library

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */


//#include <iostream>

#include "registry.h"


// this dependence the last, and should be soon deprecated
#include "../extensions/simplestorage.h"

using namespace Onion;

Storage *Storage::makeStorage(const Node &node)
	throw(OperationNotSupported, StorageNotSupported, MetaKeyNotFound)
{
	std::string storage = *node.getMetaKey("storage");

	if(storage == "SimpleStorage" )
	{
		return new SimpleStorage(
			node.getMetaKey("filename")->getValue());
	}
	else
		throw StorageNotSupported(storage);
}

Storage::~Storage()
{
}

// <EOF>
