#include "testRegistry.h"
#include "testCatalog.h"
#include "testNode.h"
#include "testKey.h"
#include "testMetaKey.h"
#include "testStorage.h"

#include "cppunit/TextTestResult.h"
#include "cppunit/TestSuite.h"

#include <string>
#include <iostream>

using namespace Onion;

int main()
{
	std::cerr << "test libregistry\n";
	
	CppUnit::TestSuite suite;
	suite.addTest( RegistryTest::suite() );
	suite.addTest( StorageTest::suite() );

	suite.addTest( MetaKeyTest::suite() );
	suite.addTest( NodeTest::suite() );

	suite.addTest( KeyTest::suite() );
	suite.addTest( CatalogTest::suite() );
	suite.addTest( KeyTest::suite() );
	suite.addTest( MetaKeyTest::suite() );

	CppUnit::TextTestResult res;
	try
	{
		suite.run( &res );
	}
	catch(...)
	{
		std::cout << "neizvestnaya exception\n";
	}

	std::cerr << res << std::endl;

	return 0;

}

// <EOF>
