#ifndef TESTS_METAKEYTEST_H
#define TESTS_METAKEYTEST_H

#include "cppunit/extensions/HelperMacros.h"
#include "../src/registry.h"
#include <iostream>
#include <algorithm>

class MetaKeyTest : public CppUnit::TestFixture
{
	CPPUNIT_TEST_SUITE( MetaKeyTest );

	CPPUNIT_TEST( testGetValue );
	CPPUNIT_TEST( testOperatorString );
	CPPUNIT_TEST( testOperatorAssign );
	
	CPPUNIT_TEST_SUITE_END();	

protected:
	Onion::MetaKey *m_mkey;
	Onion::Registry *m_registry;
public:
	int countTestCases() const
	{
		return 1;
	}
	
	void setUp()
	{
		m_registry = new Onion::Registry();
		Onion::Catalog *root = m_registry->getRoot();
		Onion::Catalog *catalog = root->createCatalog( "catalog" );
		m_mkey = catalog->createMetaKey( "metakey", "value" );
	}
	
	void tearDown()
	{
		delete m_registry;
	}

	void testGetValue()
	{
		CPPUNIT_ASSERT( m_registry != 0 );
		CPPUNIT_ASSERT( m_mkey != 0 );
		CPPUNIT_ASSERT( m_mkey->getValue() == "value");
	}

	void testOperatorString()
	{
		std::string value = *m_mkey;
		CPPUNIT_ASSERT( value == "value" );
	}

	void testOperatorAssign()
	{
		*m_mkey = "value2";
		CPPUNIT_ASSERT( m_mkey->getValue() == "value2" );
	}
};

#endif // TESTS_METAKEYTEST_H

// <EOF>
