#ifndef TESTS_REGISTRYTEST_H
#define TESTS_REGISTRYTEST_H

#include "cppunit/extensions/HelperMacros.h"
#include "../src/registry.h"
#include <iostream>
#include <algorithm>

class RegistryTest : public CppUnit::TestFixture
{
	CPPUNIT_TEST_SUITE( RegistryTest );
	CPPUNIT_TEST( testRoot );
	CPPUNIT_TEST_SUITE_END();
protected:
	Onion::Registry *m_registry;
	Onion::Catalog *m_root;
public:
	int countTestCases() const
	{
		return 1;
	}
	
	void setUp()
	{
		m_registry = new Onion::Registry;
		m_root = m_registry->getRoot();
	}
	
	void tearDown()
	{
		delete m_registry;
	}

	void testRoot()
	{
		CPPUNIT_ASSERT(m_registry != 0);
		CPPUNIT_ASSERT( m_root != 0 );

		CPPUNIT_ASSERT( m_root == m_root->getCatalog( "" ) );
		CPPUNIT_ASSERT( m_root == m_root->getCatalog( "/" ) );
	}
};

#endif // TESTS_REGISTRYTESTS_H

// <EOF>
