#include "OnionFM.h"
#include <eventqueue.h>
#include <registry.h>

#include <memory>

int main()
{
	std::auto_ptr<Onion::Registry> registry( new Onion::Registry() );
	Onion::Catalog *root = registry->getRoot();
	Onion::MetaKey *mkey
			= root->createMetaKey( "storage", "SimpleStorage" );
	// dont save to onion.reg this metakeys, they
	// used by parent for loading registry
	mkey->setOwnerParent( true );
	mkey = root->createMetaKey( "filename", "onion.reg" );
	mkey->setOwnerParent( true );

	try // create config if not exist
	{
		root->load( true );
	}
	catch(Onion::CantOpenStorage &s)
	{
		root->save( true );
	}

	std::auto_ptr<Onion::OnionFM> onion( new Onion::OnionFM );
	onion->readConfig( *root );
	
	std::auto_ptr<Onion::EventHandler> onion_handler( 
			onion->makeEventHandler() );

	Onion::EventController controller;

	return 0;
}

// <EOF>
