#ifndef TESTS_ONIONFMTEST_H
#define TESTS_ONIONFMTEST_H

#include "../src/OnionFM.h"

#include "cppunit/extensions/HelperMacros.h"

class OnionFMTest : public CppUnit::TestFixture
{
	CPPUNIT_TEST_SUITE( OnionFMTest );
	CPPUNIT_TEST( testReloadConfig );
	CPPUNIT_TEST( testMakeEventHandler );
	CPPUNIT_TEST_SUITE_END();
protected:
	Onion::OnionFM *m_fm;
public:

	int countTestCases() const
	{
		return 1;
	}
	
	void setUp()
	{
		m_fm = new Onion::OnionFM();
	}
	
	void tearDown()
	{
		delete m_fm;
	}

	void testReloadConfig()
	{
		Onion::Registry *registry = new Onion::Registry();
		CPPUNIT_ASSERT( registry != 0 );
		
		Onion::Catalog *root = registry->getRoot();
		CPPUNIT_ASSERT( root != 0 );
		
		Onion::MetaKey *mkey = root->createMetaKey( "storage",
			"SimpleStorage" );
		CPPUNIT_ASSERT( mkey != 0 );

		mkey = root->createMetaKey( "filename", "testOninoFM.reg" );
		CPPUNIT_ASSERT( mkey != 0 );
		
		m_fm->readConfig( *root );
		
		delete registry;
	}
	
	void testMakeEventHandler()
	{
		Onion::EventHandler *handler = m_fm->makeEventHandler();
		CPPUNIT_ASSERT( handler != 0 );
		delete handler;
	}

}; // class OnionFMTest

#endif // TESTS_ONIONTEST_H

// <EOF>
